from collections import deque, defaultdict

def find_guarded_storages(n, m, k, roads, guards):
    # Создаем граф как словарь смежности
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    # Множество охраняемых складов
    guarded = set()

    # Обрабатываем каждого охранника
    for p, h in guards:
        # BFS для поиска охраняемых складов
        queue = deque([(p, 0)])  # (текущий склад, текущая дистанция)
        visited = set()
        visited.add(p)

        while queue:
            current, distance = queue.popleft()
            if distance <= h:
                guarded.add(current)
                for neighbor in graph[current]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, distance + 1))

    # Результаты
    guarded = sorted(guarded)
    return len(guarded), guarded

# Пример использования
n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

count, guarded_storages = find_guarded_storages(n, m, k, roads, guards)
print(count)
print(' '.join(map(str, guarded_storages)))
